#include<iostream>
using namespace std;
int main(){
	int s=0;
	int n,k;
	cin>>n>>k;
	int niz[n];
	for(int i=0;i<n;i++){
		cin>>niz[i];
		s+=niz[i];
	}
	if(k==0){
		cout<<s;
		return 0;
	}
	long long r=0;
	//za k je 1
	for(int i=0;i<n;i++){
		r+=niz[i];
		for(int j=i+1;j<n;j++){
			for(int x=i;x<=j;x++){
				r+=niz[x];
			}
		}
	}
	cout<<r%1000000007<<endl;
	return 0;
}